﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Net;
using System.ServiceModel;
using System.ServiceModel.Channels;
using System.Text;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

public partial class _Default : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        ProcessProxyRequest("http://eh-x1:7048/DynamicsNAV70/OData/", Request, Response);
    }
    void ProcessProxyRequest(string requesturl, HttpRequest request, HttpResponse response)
    {
        string LastPartOfRequest = request.Url.PathAndQuery.Substring(request.Url.PathAndQuery.IndexOf(".aspx/") + 6);
        HttpWebRequest webRequest = HttpWebRequest.Create(requesturl + LastPartOfRequest) as HttpWebRequest;

        webRequest.KeepAlive = false;
        webRequest.Credentials = CredentialCache.DefaultCredentials;
        webRequest.Method = request.HttpMethod;
        webRequest.ContentType = request.ContentType;
        webRequest.ContentLength = request.ContentLength;
        foreach (string Key in Request.Headers) // Add headers we might be missing..
        {
            try
            {
                webRequest.Headers.Add(Key, Request.Headers[Key]);
            }
            catch { }
        }
        if (webRequest.Method == "POST")
        {
            Stream x = webRequest.GetRequestStream();
            int l = (int)Request.InputStream.Length;
            request.InputStream.CopyTo(x, l);
            x.Close();
        }
        using (HttpWebResponse backendResponse = (HttpWebResponse)webRequest.GetResponse())
        {
            Stream receiveStream = backendResponse.GetResponseStream();

            response.Clear();
            response.ClearContent();
            response.ClearHeaders();

            foreach (string header in backendResponse.Headers)
                response.AppendHeader(header, backendResponse.Headers[header]);
            // Copy content           
            receiveStream.CopyTo(response.OutputStream);
            receiveStream.Close();
            backendResponse.Close();
        }
    }
}